diff --git a/test/containers/unord/unord.set/find_const.pass.cpp b/test/containers/unord/unord.set/find_const.pass.cpp
index ca8b9e6..e2238e5 100644
--- a/test/containers/unord/unord.set/find_const.pass.cpp
+++ b/test/containers/unord/unord.set/find_const.pass.cpp
@@ -18,7 +18,7 @@
 #include <unordered_set>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/find_non_const.pass.cpp b/test/containers/unord/unord.set/find_non_const.pass.cpp
index a2ab804..8afe32a 100644
--- a/test/containers/unord/unord.set/find_non_const.pass.cpp
+++ b/test/containers/unord/unord.set/find_non_const.pass.cpp
@@ -18,7 +18,7 @@
 #include <unordered_set>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/insert_const_lvalue.pass.cpp b/test/containers/unord/unord.set/insert_const_lvalue.pass.cpp
index b5d2733..321e905 100644
--- a/test/containers/unord/unord.set/insert_const_lvalue.pass.cpp
+++ b/test/containers/unord/unord.set/insert_const_lvalue.pass.cpp
@@ -18,7 +18,7 @@
 #include <unordered_set>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/insert_hint_const_lvalue.pass.cpp b/test/containers/unord/unord.set/insert_hint_const_lvalue.pass.cpp
index c195e52..1393f54 100644
--- a/test/containers/unord/unord.set/insert_hint_const_lvalue.pass.cpp
+++ b/test/containers/unord/unord.set/insert_hint_const_lvalue.pass.cpp
@@ -22,7 +22,7 @@
 #include <unordered_set>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/insert_hint_rvalue.pass.cpp b/test/containers/unord/unord.set/insert_hint_rvalue.pass.cpp
index ff7d742..f612ec5 100644
--- a/test/containers/unord/unord.set/insert_hint_rvalue.pass.cpp
+++ b/test/containers/unord/unord.set/insert_hint_rvalue.pass.cpp
@@ -23,7 +23,7 @@
 #include <cassert>
 
 #include "../../MoveOnly.h"
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/insert_init.pass.cpp b/test/containers/unord/unord.set/insert_init.pass.cpp
index 18a97a1..2d8eafb 100644
--- a/test/containers/unord/unord.set/insert_init.pass.cpp
+++ b/test/containers/unord/unord.set/insert_init.pass.cpp
@@ -19,7 +19,7 @@
 #include <cassert>
 
 #include "test_iterators.h"
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/insert_range.pass.cpp b/test/containers/unord/unord.set/insert_range.pass.cpp
index aa3b38b..72a83ab 100644
--- a/test/containers/unord/unord.set/insert_range.pass.cpp
+++ b/test/containers/unord/unord.set/insert_range.pass.cpp
@@ -20,7 +20,7 @@
 #include <cassert>
 
 #include "test_iterators.h"
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/insert_rvalue.pass.cpp b/test/containers/unord/unord.set/insert_rvalue.pass.cpp
index 9ed2cda..d62308e 100644
--- a/test/containers/unord/unord.set/insert_rvalue.pass.cpp
+++ b/test/containers/unord/unord.set/insert_rvalue.pass.cpp
@@ -19,7 +19,7 @@
 #include <cassert>
 
 #include "../../MoveOnly.h"
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/iterators.pass.cpp b/test/containers/unord/unord.set/iterators.pass.cpp
index 7bb9770..d88310e 100644
--- a/test/containers/unord/unord.set/iterators.pass.cpp
+++ b/test/containers/unord/unord.set/iterators.pass.cpp
@@ -23,7 +23,7 @@
 #include <unordered_set>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/load_factor.pass.cpp b/test/containers/unord/unord.set/load_factor.pass.cpp
index 959f384..e0ed169 100644
--- a/test/containers/unord/unord.set/load_factor.pass.cpp
+++ b/test/containers/unord/unord.set/load_factor.pass.cpp
@@ -19,7 +19,7 @@
 #include <cassert>
 #include <cfloat>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/local_iterators.pass.cpp b/test/containers/unord/unord.set/local_iterators.pass.cpp
index 5b82228..2ffd93f 100644
--- a/test/containers/unord/unord.set/local_iterators.pass.cpp
+++ b/test/containers/unord/unord.set/local_iterators.pass.cpp
@@ -23,7 +23,7 @@
 #include <unordered_set>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/max_bucket_count.pass.cpp b/test/containers/unord/unord.set/max_bucket_count.pass.cpp
index 80398b8..8b5e265 100644
--- a/test/containers/unord/unord.set/max_bucket_count.pass.cpp
+++ b/test/containers/unord/unord.set/max_bucket_count.pass.cpp
@@ -18,7 +18,7 @@
 #include <unordered_set>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/max_load_factor.pass.cpp b/test/containers/unord/unord.set/max_load_factor.pass.cpp
index 982c6b5..d326f4a 100644
--- a/test/containers/unord/unord.set/max_load_factor.pass.cpp
+++ b/test/containers/unord/unord.set/max_load_factor.pass.cpp
@@ -23,7 +23,7 @@
 #include <unordered_set>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/max_size.pass.cpp b/test/containers/unord/unord.set/max_size.pass.cpp
index 43d66bb..1c6e741 100644
--- a/test/containers/unord/unord.set/max_size.pass.cpp
+++ b/test/containers/unord/unord.set/max_size.pass.cpp
@@ -18,7 +18,7 @@
 #include <unordered_set>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/rehash.pass.cpp b/test/containers/unord/unord.set/rehash.pass.cpp
index bf4d317..30fffa5 100644
--- a/test/containers/unord/unord.set/rehash.pass.cpp
+++ b/test/containers/unord/unord.set/rehash.pass.cpp
@@ -18,7 +18,7 @@
 #include <unordered_set>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class C>
 void test(const C& c)
diff --git a/test/containers/unord/unord.set/reserve.pass.cpp b/test/containers/unord/unord.set/reserve.pass.cpp
index 525f943..7d6656a 100644
--- a/test/containers/unord/unord.set/reserve.pass.cpp
+++ b/test/containers/unord/unord.set/reserve.pass.cpp
@@ -18,7 +18,7 @@
 #include <unordered_set>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class C>
 void test(const C& c)
diff --git a/test/containers/unord/unord.set/swap_member.pass.cpp b/test/containers/unord/unord.set/swap_member.pass.cpp
index 9a972b7..4497606 100644
--- a/test/containers/unord/unord.set/swap_member.pass.cpp
+++ b/test/containers/unord/unord.set/swap_member.pass.cpp
@@ -21,7 +21,7 @@
 #include "../../test_compare.h"
 #include "../../test_hash.h"
 #include "../../test_allocator.h"
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/types.pass.cpp b/test/containers/unord/unord.set/types.pass.cpp
index 11d992f..d315a86 100644
--- a/test/containers/unord/unord.set/types.pass.cpp
+++ b/test/containers/unord/unord.set/types.pass.cpp
@@ -30,7 +30,8 @@
 #include <unordered_set>
 #include <type_traits>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
+#include "powerpc-darwin.h"
 
 int main()
 {
@@ -45,7 +46,11 @@ int main()
         static_assert((std::is_same<C::const_reference, const C::value_type&>::value), "");
         static_assert((std::is_same<C::pointer, C::value_type*>::value), "");
         static_assert((std::is_same<C::const_pointer, const C::value_type*>::value), "");
+#ifdef	PTRDIFF_T_VS_SIZE_T_DIFFER
+        static_assert(sizeof(C::size_type) == sizeof(std::size_t), "");
+#else
         static_assert((std::is_same<C::size_type, std::size_t>::value), "");
+#endif
         static_assert((std::is_same<C::difference_type, std::ptrdiff_t>::value), "");
     }
 #if __cplusplus >= 201103L
@@ -61,7 +66,11 @@ int main()
         static_assert((std::is_same<C::const_reference, const C::value_type&>::value), "");
         static_assert((std::is_same<C::pointer, min_pointer<C::value_type>>::value), "");
         static_assert((std::is_same<C::const_pointer, min_pointer<const C::value_type>>::value), "");
+#ifdef	PTRDIFF_T_VS_SIZE_T_DIFFER
+        static_assert(sizeof(C::size_type) == sizeof(std::size_t), "");
+#else
         static_assert((std::is_same<C::size_type, std::size_t>::value), "");
+#endif
         static_assert((std::is_same<C::difference_type, std::ptrdiff_t>::value), "");
     }
 #endif
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/allocator.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/allocator.pass.cpp
index 5d7897b..3e22134 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/allocator.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/allocator.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/assign_copy.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/assign_copy.pass.cpp
index e7fa903..e53656a 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/assign_copy.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/assign_copy.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/assign_init.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/assign_init.pass.cpp
index 256f444..55c8df6 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/assign_init.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/assign_init.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/assign_move.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/assign_move.pass.cpp
index a197fca..50ce419 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/assign_move.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/assign_move.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/copy.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/copy.pass.cpp
index 7fe0e15..dbed56c 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/copy.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/copy.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/copy_alloc.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/copy_alloc.pass.cpp
index 67995b3..4265e30 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/copy_alloc.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/copy_alloc.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/default.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/default.pass.cpp
index e53264f..6eaa8c2 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/default.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/default.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/init.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/init.pass.cpp
index fcee400..8e5938e 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/init.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/init.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/init_size.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/init_size.pass.cpp
index 3cc3cf0..4872bab 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/init_size.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/init_size.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/init_size_hash.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/init_size_hash.pass.cpp
index 9dc61fb..2905c04 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/init_size_hash.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/init_size_hash.pass.cpp
@@ -23,7 +23,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/init_size_hash_equal.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/init_size_hash_equal.pass.cpp
index a191c7c..04c7b8a 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/init_size_hash_equal.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/init_size_hash_equal.pass.cpp
@@ -23,7 +23,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/init_size_hash_equal_allocator.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/init_size_hash_equal_allocator.pass.cpp
index 4a1fc6c..e8875ab 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/init_size_hash_equal_allocator.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/init_size_hash_equal_allocator.pass.cpp
@@ -23,7 +23,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/move.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/move.pass.cpp
index 3f1685c..11191a1 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/move.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/move.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/move_alloc.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/move_alloc.pass.cpp
index 1e58dbd..c977057 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/move_alloc.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/move_alloc.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/range.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/range.pass.cpp
index d0166fa..24a6e35 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/range.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/range.pass.cpp
@@ -24,7 +24,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/range_size.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/range_size.pass.cpp
index 87e62a0..e4ed134 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/range_size.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/range_size.pass.cpp
@@ -24,7 +24,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/range_size_hash.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/range_size_hash.pass.cpp
index 6f6f178..b0e568a 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/range_size_hash.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/range_size_hash.pass.cpp
@@ -25,7 +25,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/range_size_hash_equal.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/range_size_hash_equal.pass.cpp
index ac2aafd..90c419b 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/range_size_hash_equal.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/range_size_hash_equal.pass.cpp
@@ -25,7 +25,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/range_size_hash_equal_allocator.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/range_size_hash_equal_allocator.pass.cpp
index 5a051e8..0f89258 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/range_size_hash_equal_allocator.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/range_size_hash_equal_allocator.pass.cpp
@@ -26,7 +26,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/size.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/size.pass.cpp
index fe01966..450f2dd 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/size.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/size.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/size_hash.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/size_hash.pass.cpp
index 2bda6cc..b2b7da7 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/size_hash.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/size_hash.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/size_hash_equal.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/size_hash_equal.pass.cpp
index bd5e754..9a52988 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/size_hash_equal.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/size_hash_equal.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.cnstr/size_hash_equal_allocator.pass.cpp b/test/containers/unord/unord.set/unord.set.cnstr/size_hash_equal_allocator.pass.cpp
index e3378ce..d20e03f 100644
--- a/test/containers/unord/unord.set/unord.set.cnstr/size_hash_equal_allocator.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.cnstr/size_hash_equal_allocator.pass.cpp
@@ -22,7 +22,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/containers/unord/unord.set/unord.set.swap/swap_non_member.pass.cpp b/test/containers/unord/unord.set/unord.set.swap/swap_non_member.pass.cpp
index 57899ae..f529ad6 100644
--- a/test/containers/unord/unord.set/unord.set.swap/swap_non_member.pass.cpp
+++ b/test/containers/unord/unord.set/unord.set.swap/swap_non_member.pass.cpp
@@ -21,7 +21,7 @@
 #include "../../../test_compare.h"
 #include "../../../test_hash.h"
 #include "../../../test_allocator.h"
-#include "../../../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/language.support/support.limits/limits/numeric.limits.members/is_iec559.pass.cpp b/test/language.support/support.limits/limits/numeric.limits.members/is_iec559.pass.cpp
index f6b8682..1b73bda 100644
--- a/test/language.support/support.limits/limits/numeric.limits.members/is_iec559.pass.cpp
+++ b/test/language.support/support.limits/limits/numeric.limits.members/is_iec559.pass.cpp
@@ -44,5 +44,9 @@ int main()
     test<unsigned long long, false>();
     test<float, true>();
     test<double, true>();
+#if (defined(__ppc__) || defined(__ppc64__))
+    test<long double, false>();
+#else
     test<long double, true>();
+#endif
 }
diff --git a/test/language.support/support.limits/limits/numeric.limits.members/traps.pass.cpp b/test/language.support/support.limits/limits/numeric.limits.members/traps.pass.cpp
index 611ce56..fbf292b 100644
--- a/test/language.support/support.limits/limits/numeric.limits.members/traps.pass.cpp
+++ b/test/language.support/support.limits/limits/numeric.limits.members/traps.pass.cpp
@@ -23,25 +23,32 @@ test()
     static_assert(std::numeric_limits<const volatile T>::traps == expected, "traps test 4");
 }
 
+// see <limits>:
+#if	(defined(__i386__) || defined(__x86_64__))
+static const bool is_x86 = true;
+#else
+static const bool is_x86 = false;
+#endif
+
 int main()
 {
     test<bool, false>();
-    test<char, true>();
-    test<signed char, true>();
-    test<unsigned char, true>();
-    test<wchar_t, true>();
+    test<char, is_x86>();
+    test<signed char, is_x86>();
+    test<unsigned char, is_x86>();
+    test<wchar_t, is_x86>();
 #ifndef _LIBCPP_HAS_NO_UNICODE_CHARS
-    test<char16_t, true>();
-    test<char32_t, true>();
+    test<char16_t, is_x86>();
+    test<char32_t, is_x86>();
 #endif  // _LIBCPP_HAS_NO_UNICODE_CHARS
-    test<short, true>();
-    test<unsigned short, true>();
-    test<int, true>();
-    test<unsigned int, true>();
-    test<long, true>();
-    test<unsigned long, true>();
-    test<long long, true>();
-    test<unsigned long long, true>();
+    test<short, is_x86>();
+    test<unsigned short, is_x86>();
+    test<int, is_x86>();
+    test<unsigned int, is_x86>();
+    test<long, is_x86>();
+    test<unsigned long, is_x86>();
+    test<long long, is_x86>();
+    test<unsigned long long, is_x86>();
     test<float, false>();
     test<double, false>();
     test<long double, false>();
diff --git a/test/lit.cfg b/test/lit.cfg
index aa45439..bf2ee2c 100644
--- a/test/lit.cfg
+++ b/test/lit.cfg
@@ -181,10 +181,11 @@ if cxx_under_test is None:
     cxx_under_test = getattr(config, 'cxx_under_test', None)
 
     # If no specific cxx_under_test was given, attempt to infer it as clang++.
-    clangxx = lit.util.which('clang++', config.environment['PATH'])
-    if clangxx is not None:
-        cxx_under_test = clangxx
-        lit_config.note("inferred cxx_under_test as: %r" % (cxx_under_test,))
+    if cxx_under_test is None:
+        clangxx = lit.util.which('clang++', config.environment['PATH'])
+        if clangxx is not None:
+            cxx_under_test = clangxx
+    lit_config.note("inferred cxx_under_test as: %r" % (cxx_under_test,))
 if cxx_under_test is None:
     lit_config.fatal('must specify user parameter cxx_under_test '
                      '(e.g., --param=cxx_under_test=clang++)')
@@ -213,6 +214,19 @@ if cxx_has_stdcxx0x_flag_str is not None:
 else:
     cxx_has_stdcxx0x_flag = getattr(config, 'cxx_has_stdcxx0x_flag', True)
 
+# global linker flags, like -B
+exe_linker_flags = lit_config.params.get('exe_linker_flags', None)
+if exe_linker_flags is None:
+    exe_linker_flags = getattr(config, 'exe_linker_flags', '')
+exe_linker_flags = exe_linker_flags.split(' ')
+lit_config.note("inferred exe_linker_flags as: %r" % (exe_linker_flags,))
+
+cxx_flags = lit_config.params.get('cxx_flags', None)
+if cxx_flags is None:
+    cxx_flags = getattr(config, 'cxx_flags', '')
+cxx_flags = cxx_flags.split(' ')
+lit_config.note("inferred cxx_flags as: %r" % (cxx_flags,))
+
 # This test suite supports testing against either the system library or the
 # locally built one; the former mode is useful for testing ABI compatibility
 # between the current headers and a shipping dynamic library.
@@ -247,7 +261,33 @@ if link_flags_str is None:
         lit_config.fatal('C++ ABI setting %s unsupported for tests' % cxx_abi)
 
       if sys.platform == 'darwin':
+        # need libgcc_s for libunwind
+        darwin_vers = int(platform.release().split('.')[0])
+        osx_vers_maj = '.'.join(platform.mac_ver()[0].split('.')[0:2])
+        if darwin_vers < 10:
+          link_flags += ['.'.join(['-lgcc_s', osx_vers_maj])]
+        elif darwin_vers < 11:
+          link_flags += ['-lgcc_s.1']
+        # need libclang_rt for eprintf
+        arch = platform.processor()
+        if arch == 'powerpc':
+          arch = 'ppc'
+        libcrt = '.'.join(['libclang_rt', arch, 'a'])
+        cmd = [cxx_under_test, '-print-search-dirs']
+        p = subprocess.Popen(cmd, stdout=subprocess.PIPE)
+        out,err = p.communicate()
+        exitCode = p.wait()
+        # should probably check exitCode
+        for l in out.splitlines():
+          ll = l.split(' ')
+          if ll[0] == 'libraries:':
+            crt_libdir = ll[1][1:]
+        
+        link_flags += [os.path.join(crt_libdir, 'lib', sys.platform, libcrt)]
         link_flags += ['-lSystem']
+        # better yet, test existence of SystemStubs
+        if darwin_vers < 11:
+          link_flags += ['-lSystemStubs']
       elif sys.platform == 'linux2':
         link_flags += [ '-lgcc_eh', '-lc', '-lm', '-lpthread',
               '-lrt', '-lgcc_s']
@@ -281,8 +321,8 @@ else:
 
 config.test_format = LibcxxTestFormat(
     cxx_under_test,
-    cpp_flags = ['-nostdinc++'] + compile_flags + include_paths,
-    ld_flags = ['-nodefaultlibs'] + library_paths + ['-lc++'] + link_flags,
+    cpp_flags = cxx_flags + ['-nostdinc++'] + compile_flags + include_paths,
+    ld_flags = exe_linker_flags + ['-nodefaultlibs'] + library_paths + ['-lc++'] + link_flags,
     exec_env = exec_env)
 
 # Get or infer the target triple.
diff --git a/test/lit.site.cfg.in b/test/lit.site.cfg.in
index 5343eda..56068c2 100644
--- a/test/lit.site.cfg.in
+++ b/test/lit.site.cfg.in
@@ -6,6 +6,9 @@ config.libcxx_obj_root       = "@LIBCXX_BINARY_DIR@"
 config.python_executable     = "@PYTHON_EXECUTABLE@"
 config.enable_shared         = @LIBCXX_ENABLE_SHARED@
 config.cxx_abi               = "@LIBCXX_CXX_ABI@"
+# use same options used to build libc++
+config.exe_linker_flags      = "@CMAKE_EXE_LINKER_FLAGS@"
+config.cxx_flags             = "@CMAKE_CXX_FLAGS@"
 
 # Let the main config do the real work.
 lit_config.load_config(config, "@LIBCXX_SOURCE_DIR@/test/lit.cfg")
diff --git a/test/strings/basic.string/string.access/at.pass.cpp b/test/strings/basic.string/string.access/at.pass.cpp
index e24b560..8fada8f 100644
--- a/test/strings/basic.string/string.access/at.pass.cpp
+++ b/test/strings/basic.string/string.access/at.pass.cpp
@@ -16,7 +16,7 @@
 #include <stdexcept>
 #include <cassert>
 
-#include "../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.access/back.pass.cpp b/test/strings/basic.string/string.access/back.pass.cpp
index ed0d327..e915214 100644
--- a/test/strings/basic.string/string.access/back.pass.cpp
+++ b/test/strings/basic.string/string.access/back.pass.cpp
@@ -19,7 +19,7 @@
 #include <string>
 #include <cassert>
 
-#include "../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.access/db_back.pass.cpp b/test/strings/basic.string/string.access/db_back.pass.cpp
index b153249..2b31fab 100644
--- a/test/strings/basic.string/string.access/db_back.pass.cpp
+++ b/test/strings/basic.string/string.access/db_back.pass.cpp
@@ -21,7 +21,7 @@
 #include <exception>
 #include <cstdlib>
 
-#include "../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/strings/basic.string/string.access/db_cback.pass.cpp b/test/strings/basic.string/string.access/db_cback.pass.cpp
index ece27a6..7feb423 100644
--- a/test/strings/basic.string/string.access/db_cback.pass.cpp
+++ b/test/strings/basic.string/string.access/db_cback.pass.cpp
@@ -21,7 +21,7 @@
 #include <exception>
 #include <cstdlib>
 
-#include "../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/strings/basic.string/string.access/db_cfront.pass.cpp b/test/strings/basic.string/string.access/db_cfront.pass.cpp
index d36885e..9f7785b 100644
--- a/test/strings/basic.string/string.access/db_cfront.pass.cpp
+++ b/test/strings/basic.string/string.access/db_cfront.pass.cpp
@@ -21,7 +21,7 @@
 #include <exception>
 #include <cstdlib>
 
-#include "../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/strings/basic.string/string.access/db_cindex.pass.cpp b/test/strings/basic.string/string.access/db_cindex.pass.cpp
index 385c219..6294200 100644
--- a/test/strings/basic.string/string.access/db_cindex.pass.cpp
+++ b/test/strings/basic.string/string.access/db_cindex.pass.cpp
@@ -21,7 +21,7 @@
 #include <exception>
 #include <cstdlib>
 
-#include "../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
diff --git a/test/strings/basic.string/string.access/db_front.pass.cpp b/test/strings/basic.string/string.access/db_front.pass.cpp
index 15985fa..ff675bc 100644
--- a/test/strings/basic.string/string.access/db_front.pass.cpp
+++ b/test/strings/basic.string/string.access/db_front.pass.cpp
@@ -21,7 +21,7 @@
 #include <exception>
 #include <cstdlib>
 
-#include "../min_allocator.h"
+#include "min_allocator.h"
 
 int main()
 {
